/*********************************************************************
 *
 * Class   : EIBLampButton.java
 *
 * Author  : Georg Walkner
 *
 * Purpose : JButton Extension
 *
 * Date    : 05-Mar-2002
 *
 ********************************************************************/
package EIB;

import java.io.*;

import javax.swing.*;
//import javax.swing.event.*;
import java.awt.*;
import java.awt.event.*;

import com.eiblet.bus.*;
import com.eiblet.bus.eib.*;
import com.eiblet.util.*;


public class EIBLampButton extends JButton
    implements ActionListener, BusCommunicatorStatusEventListener
{
    private EIBLowLevelGroupObjectBusCommunicator fEIBLowLevelBC = null;
    public EIBGroupObject fGroupObject = null;
    public static final byte[] pEin = {1};
    public static final byte[] pAus = {0};
    
    public EIBLampButton(String pButtonName, 
		     EIBGroupAddress pEIBGroupAddress, 
		     EISType pEISType, 
		     EIBLowLevelGroupObjectBusCommunicator pEIBLowLevelBC)
    {
	super(pButtonName);
	fEIBLowLevelBC = pEIBLowLevelBC;
	fEIBLowLevelBC.addBusCommunicatorStatusEventListener(this);
	fGroupObject = new EIBGroupObject(pEIBGroupAddress, pEISType, pEIBLowLevelBC);
	this.addActionListener(this);
	this.setBackground(Color.white);
    }
    
    
    public void handleEvent(EIBLowLevelGroupObjectBusCommunicatorEvent pEvent)
    {
	if(fGroupObject.getEIBGroupAddress().equals(pEvent.getEIBGroupAddress()))
	    {
		fGroupObject.setData(pEvent.getData());
		if((fGroupObject.getData())[0] == pEin[0])
		    this.setBackground(Color.yellow);
		else this.setBackground(Color.white);
	    }
    }
    
    public void handleBusCommunicatorStatusEvent(BusCommunicatorStatusEvent pEvent){
	if(BusCommunicatorStatusEvent.STATUS_DISCONNECTED == pEvent.getStatus()){
	    this.setBackground(Color.lightGray);
	}
    }   

    public void actionPerformed(ActionEvent evt)
    {
	try{
	    if((fGroupObject.getData())[0] == pAus[0])
		fGroupObject.writeGroupData(pEin);
	    else
		fGroupObject.writeGroupData(pAus);
	}
	catch(IOException e){
	    System.out.println(e.getMessage());
	}
    }
}
