/*********************************************************************
 *
 * Class   : EIBTableModel.java
 *
 * Author  : Georg Walkner
 *
 * Purpose : LogList
 *
 * Date    : 05-Mar-2002
 *
 ********************************************************************/
package EIB;

import java.util.*;

import javax.swing.event.*;
import javax.swing.table.*;

import com.eiblet.bus.*;
import com.eiblet.bus.eib.*;
import com.eiblet.util.*;

public class EIBTableModel
    implements TableModel
{
    private Vector LogEntries  = new Vector();
    private Vector TMListeners = new Vector();
    private int cnt = 0;

    private static final int NR_ENTRIES = 10;

    public EIBTableModel()
    {

    }

    public Class getColumnClass(int ColumnIndex) 
    {
	Class foo = null;
	try {
	    switch(ColumnIndex){
	    case 0: foo = Class.forName("java.lang.Integer");
		break;
	    case 1: foo = Class.forName("java.lang.String");
		break;
	    default:foo = Class.forName("java.lang.String");
		break;
	    }
	}
	catch(ClassNotFoundException ex) {
	    ex.printStackTrace();
	}
	return foo;
    }
    
    public int getColumnCount()
    {
	return 4;
    }
    
    public String getColumnName(int ColumnIndex)
    {
	String foo = null;
	switch(ColumnIndex) {
	case 0: foo = "#"; break;
	case 1: foo = "Group Adr"; break;
	case 2: foo = "Data"; break;
	case 3: foo = "EIS Type"; break;
	default:foo = "not found";break;
	}
	return foo;
    }
    
    public int getRowCount()
    {
	return LogEntries.size();
    }
    
    public Object getValueAt(int rowIndex, int columnIndex)
    {
	String foo = "";

	switch(columnIndex) {
	case 0:
	    return new Integer(cnt + LogEntries.size() - rowIndex - 1);
	case 1: 
	    foo = "  " + ((EIBGroupObject)LogEntries.elementAt(rowIndex)).
		getEIBGroupAddress().
		getGroupAddress(EIBGroupAddress.FORMAT_THREE_PART);
	    break;
	case 2:
	    byte[] bar = ((EIBGroupObject)LogEntries.elementAt(rowIndex)).getData();
	    try {
		for(int i=0; i < bar.length; ++i) {
		    foo = foo + Integer.toString(bar[i]) + " ";
		}
	    } catch(Exception e) {}

	default: ;
	    break;
	}

	return foo;
    }

    public void setValueAt(Object aValue, int rowIndex, int columnIndex)
    {

    }

    public void addLogEntry(EIBGroupObject grobj) {
	cnt++;
	if(LogEntries.size() == NR_ENTRIES) {
	    LogEntries.remove(NR_ENTRIES - 1);
	}

	LogEntries.add(0, grobj);

	sendMessage();
    }
    
    
    public boolean isCellEditable(int rowIndex, int columnIndex) {
	return false; 
    }

    public void addTableModelListener(TableModelListener l)	{
	if(!TMListeners.contains(l))
	    TMListeners.add(l);
    }

    public void removeTableModelListener(TableModelListener l)
    {
	if(TMListeners.contains(l))
	    TMListeners.remove(l);
    }

    private void sendMessage() {

	TableModelEvent ev = new TableModelEvent(this);
	
	for(int i = 0; i < TMListeners.size(); ++i) {
	    try {
		((TableModelListener)TMListeners.elementAt(i)).tableChanged(ev);
	    } catch (Exception ex) {
		ex.printStackTrace();
	    }
	}
    }    
}
